﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;
using System.IO;

namespace Excel
{
    class Precio
    {
        //clases
        public static Funciones lib;

        public Precio()
        {
            lib = new Funciones();
        }

        public double PRICE(DateTime settlement, DateTime maturity, double rate, double yld, double redemption, double frequency, int basis)
        {

            double E = lib.COUPDAYS(settlement, maturity, frequency, basis);
            //Console.WriteLine("E: "+E);
            double N = lib.COUPNUM(settlement, maturity, frequency, basis);
            //Console.WriteLine("N: "+N);
            double A = lib.COUPDAYBS(settlement, maturity, frequency, basis);
            //Console.WriteLine("A: "+A);
            double DSC = lib.COUPDAYSNC(settlement, maturity, frequency, basis);
            //Console.WriteLine("DSC: "+DSC);

            double presentValueOfRedemption = redemption / Math.Pow((1.00 + (yld / frequency)), (N - 1.00 + (DSC / E)));
            double presentValueOfCouponPayments = 0;
            for (int k = 1; k <= N; k++)
            {
                presentValueOfCouponPayments += (100.00 * rate / frequency) / Math.Pow((1.00 + (yld / frequency)), (k - 1.00 + (DSC / E)));
            }
            double accruedInterest = 100.00 * (rate / frequency) * (A / E);
            return (presentValueOfRedemption + presentValueOfCouponPayments - accruedInterest);
        }

        public double DerivativePRICE(DateTime settlement, DateTime maturity, double rate, double yld, double redemption, double frequency, int basis)
        {
            double E = lib.COUPDAYS(settlement, maturity, frequency, basis);
            double N = lib.COUPNUM(settlement, maturity, frequency, basis);
            double A = lib.COUPDAYBS(settlement, maturity, frequency, basis);
            double DSC = lib.COUPDAYSNC(settlement, maturity, frequency, basis);

            double presentValueOfRedemption = redemption * (1.00 - N - DSC / E) * Math.Pow(1.00 + yld / frequency, -N - DSC / E);
            double presentValueOfCouponPayments = 0;
            for (int k = 1; k <= N; k++)
            {
                presentValueOfCouponPayments += (100.00 * (1.00 - k - DSC / E) * rate * Math.Pow(1.00 + yld / frequency, -k - DSC / E)) / Math.Pow(frequency, 2.00);
            }
            double accruedInterest = 100.00 * (rate / frequency) * (A / E);
            return presentValueOfRedemption + presentValueOfCouponPayments - accruedInterest;
        }

    }
}
