﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Excel
{
    class Rendimiento
    {

        public static Precio Price;
        public static Funciones lib;
        public static Newton metodo;

        public Rendimiento()
        {
            metodo = new Newton();
            lib = new Funciones();
            Price = new Precio();
        }

        public double YIELD(DateTime settlement, DateTime maturity, double rate, double pr, double redemption, int frequency, int basis)
        {
            if (lib.COUPNUM(settlement, maturity, frequency, basis) <= 1)
            {
                return YIELDforOnlyOnePeriod(settlement, maturity, rate, pr, redemption, frequency, basis);
            }

            //YIELDforOnlyOnePeriod for starting value is an error!
            return metodo.Solve(x => Price.PRICE(settlement, maturity, rate, x, redemption, frequency, basis) - pr, y => Price.DerivativePRICE(settlement, maturity, rate, y, redemption, frequency, basis), 100, 0.05);
        }

        public double YIELDforOnlyOnePeriod(DateTime settlement, DateTime maturity, double rate, double pr, double redemption, int frequency, int basis)
        {
            double E = lib.COUPDAYS(settlement, maturity, frequency, basis);
            double A = lib.COUPDAYBS(settlement, maturity, frequency, basis);
            double DSR = lib.COUPDAYSNC(settlement, maturity, frequency, basis);

            return ((redemption / 100.00 + rate / frequency) - (pr / 100.00 + A / E * rate / frequency)) / (pr / 100.00 + A / E * rate / frequency) * frequency * E / DSR;
        }

    }
}
